=== debian/changelog ===
radare2 (6.0.4+dfsg-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: bump year.
  * d/radare2.manpages: added.
  * d/clean: updated.

 -- Alex Myczko <tar@debian.org>  Mon, 29 Sep 2025 08:39:34 +0200
